package  
{
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	
	/**
	 * Off-screen arrow indicator
	 * 
	 * @author Switchbreak
	 */
	public class Indicator extends Image 
	{
		// Embeds
		[Embed(source = "../img/Indicator.png")] private static const INDICATOR:Class;
		
		// Graphics
		private var indicator:Image;
		
		public function Indicator( setColor:uint ) 
		{
			super( INDICATOR );
			
			originX = width;
			originY = height >> 1;
			color = setColor;
			visible = false;
			smooth = true;
			relative = false;
			scrollX = 0;
			scrollY = 0;
		}
		
		public function PointAt( pointX:Number, pointY:Number ):void
		{
			var centerX:Number = FP.world.camera.x + FP.halfWidth;
			var centerY:Number = FP.world.camera.y + FP.halfHeight;
			angle = FP.angle( centerX, centerY, pointX, pointY );
			
			// Position indicator on edge of screen at closest point
			if ( pointY < centerY )
			{
				x = FP.halfWidth + -FP.halfHeight * (pointX - centerX) / (pointY - centerY);
			}
			else if ( pointY > centerY )
			{
				x = FP.halfWidth + FP.halfHeight * (pointX - centerX) / (pointY - centerY);
			}
			else
			{
				if ( pointX < centerX )
					x == 0;
				else
					x == FP.height;
			}
			
			if ( pointX < centerX )
			{
				y = FP.halfHeight + -FP.halfWidth * (pointY - centerY) / (pointX - centerX);
			}
			else if ( pointX > centerX )
			{
				y = FP.halfHeight + FP.halfWidth * (pointY - centerY) / (pointX - centerX);
			}
			else
			{
				if ( pointY < centerY )
					y == 0;
				else
					y == FP.height;
			}
			
			// Clamp indicator to screen
			if ( y < 0 )
				y = 0;
			if ( y > FP.height )
				y = FP.height;
			if ( x < 0 )
				x = 0;
			if ( x > FP.width )
				x = FP.width;
		}
		
	}

}