package  
{
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
	
	/**
	 * Life bar UI element
	 * 
	 * @author Switchbreak
	 */
	public class LifeBar extends Graphiclist 
	{
		
		// Constants
		static private const LABEL_TEXT:String = "Bacteria";
		static private const BORDER_COLOR:uint = 0xFFFFFFFF;
		static private const BACK_COLOR:uint = 0x00000000;
		static private const FILL_COLOR:uint = 0xFF0000;
		
		static private const MAX_LIFE:Number = 100;
		
		// Variables
		private var currentLife:Number;
		
		// Graphics
		private var lifeBarLabel:Text;
		private var lifeBarBorder:Image;
		private var lifeBarFill:Image;
		
		/**
		 * Create and initialize the life bar
		 */
		public function LifeBar( setX:int, setY:int, setWidth:int, setHeight:int, setBorder:int, label:String = null, textSize:uint = 16 ) 
		{
			// Initialize graphics
			var lifeBarBack:BitmapData = new BitmapData( setWidth, setHeight, true, BORDER_COLOR );
			lifeBarBack.fillRect( new Rectangle( setBorder, setBorder, setWidth - (setBorder << 1), setHeight - (setBorder << 1) ), BACK_COLOR );
			
			lifeBarBorder = new Image( lifeBarBack );
			lifeBarBorder.x = setX;
			lifeBarBorder.y = setY;
			add( lifeBarBorder );
			
			lifeBarFill = Image.createRect( lifeBarBorder.width - (setBorder << 1), lifeBarBorder.height - (setBorder << 1), FILL_COLOR );
			lifeBarFill.x = lifeBarBorder.x + setBorder;
			lifeBarFill.y = lifeBarBorder.y + setBorder;
			add( lifeBarFill );
			
			if ( label != null )
			{
				lifeBarLabel = new Text( label );
				lifeBarLabel.size = textSize;
				lifeBarLabel.width = FP.width;
				lifeBarLabel.align = "center";
				lifeBarLabel.y = lifeBarBorder.y - lifeBarLabel.height;
				add( lifeBarLabel );
			}
		}
		
		/**
		 * Set the amount of life remaining to display
		 * 
		 * @param	life
		 * Life remaining
		 */
		public function SetLife( life:Number ):void
		{
			currentLife = life;
			lifeBarFill.scaleX = currentLife / MAX_LIFE;
		}
		
	}

}