package  
{
	import flash.geom.Point;
	import flash.display.BitmapData;
	import net.flashpunk.Graphic;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
	
	/**
	 * Background starfield graphic
	 * 
	 * @author Switchbreak
	 */
	public class Starfield extends Graphic 
	{
		// Constants
		static private const STAR_COUNT:int = 5000;
		static private const DEPTH_RANGE:Number = 0.5;
		static private const SIZE_RANGE:int = 2;
		static private const RANGE:Number = 10000;
		
		// Private variables
		private var stars:Vector.<Star>;
		
		/**
		 * Create and initialize the starfield
		 */
		public function Starfield() 
		{
			stars = new Vector.<Star>( STAR_COUNT );
			for ( var i:int = 0; i < STAR_COUNT; i++ )
			{
				var star:Star = new Star();
				star.starX = FP.random * RANGE * 2 - RANGE;
				star.starY = FP.random * RANGE * 2 - RANGE;
				star.starZ = 1 - FP.random * DEPTH_RANGE;
				star.size = FP.rand( SIZE_RANGE ) + 1;
				stars[i] = star;
			}
		}
		
		override public function render(target:BitmapData, point:Point, camera:Point):void 
		{
			super.render(target, point, camera);
			
			Draw.setTarget( target );
			for ( var i:int = 0; i < STAR_COUNT; i++ )
			{
				var starX:Number = stars[i].starX * GameWorld.zoom;
				var starY:Number = stars[i].starY * GameWorld.zoom;
				starX -= (camera.x + FP.halfWidth) * stars[i].starZ - FP.halfWidth;
				starY -= (camera.y + FP.halfHeight) * stars[i].starZ - FP.halfHeight;
				Draw.rect( starX, starY, stars[i].size, stars[i].size );
			}
			Draw.resetTarget();
		}
		
	}
}

// Star data
class Star
{
	public var starX:Number;
	public var starY:Number;
	public var starZ:Number;
	public var size:int;
}