package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	
	/**
	 * Sun game object
	 * 
	 * @author Switchbreak
	 */
	public class Sun extends CelestialBody 
	{
		// Embeds
		[Embed(source = "../img/Sun.png")] static private const SUN:Class;
		
		// Constants
		static private const RADIUS:int = 100;
		static private const COLOR:uint = 0xFFFF00;
		static public const MASS:Number = 100;
		
		// Graphics
		private var sunSprite:Image;
		private var indicator:Indicator;
		
		/**
		 * Create and initialize the Sun entity
		 */
		public function Sun() 
		{
			// Create object
			sunSprite = new Image( SUN );//Image.createCircle( RADIUS, COLOR );
			sunSprite.smooth = true;
			
			super( 0, RADIUS, sunSprite, 0 );
			moving = false;
			
			// Create indicator object
			indicator = new Indicator( COLOR );
			indicator.visible = false;
			addGraphic( indicator );
		}
		
		/**
		 * Handle showing the indicator if offscreen
		 */
		override public function update():void 
		{
			super.update();
			
			// Check if the planet is off the current screen
			var screenSize:Number = radius * GameWorld.zoom;
			setHitbox( screenSize * 2, screenSize * 2, screenSize, screenSize );
			if ( !onCamera )
			{
				indicator.PointAt( x, y );
				indicator.visible = true;
			}
			else
			{
				indicator.visible = false;
			}
		}
		
	}

}