package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Stamp;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	
	/**
	 * ...
	 * @author Switchbreak
	 */
	public class TutorialScreen extends Entity 
	{
		private var callback:Function;
		private var page:int = 1;
		
		private var background:Image;
		private var titleText:Text;
		private var screenshot:Stamp;
		private var bodyText:Text;
		private var prevButton:Text;
		private var closeButton:Text;
		private var nextButton:Text;
		
		public function TutorialScreen( setCallback:Function ) 
		{
			super();
			
			callback = setCallback;
			
			background = Image.createRect( 300, 400, 0x3ea7a3, 0.95 );
			background.x = FP.halfWidth - (background.width >> 1);
			background.y = FP.halfHeight - (background.height >> 1);
			background.scrollX = 0;
			background.scrollY = 0;
			addGraphic( background );
			
			prevButton = new Text( "<< Prev" );
			prevButton.x = background.x;
			prevButton.y = background.y + background.height - prevButton.height;
			prevButton.scrollX = 0;
			prevButton.scrollY = 0;
			addGraphic( prevButton );
			
			nextButton = new Text( "Next >>" );
			nextButton.x = background.x + background.width - nextButton.width;
			nextButton.y = background.y + background.height - nextButton.height;
			nextButton.scrollX = 0;
			nextButton.scrollY = 0;
			addGraphic( nextButton );
			
			closeButton = new Text( "Close" );
			closeButton.x = background.x + (background.width >> 1) - (closeButton.width >> 1);
			closeButton.y = background.y + background.height - closeButton.height;
			closeButton.scrollX = 0;
			closeButton.scrollY = 0;
			addGraphic( closeButton );
			
			titleText = new Text( " ", background.x, background.y );
			titleText.size = 36;
			titleText.width = background.width;
			titleText.align = "center";
			titleText.scrollX = 0;
			titleText.scrollY = 0;
			addGraphic( titleText );
			
			bodyText = new Text( " ", background.x, titleText.y + titleText.height );
			bodyText.width = background.width;
			bodyText.wordWrap = true;
			bodyText.scrollX = 0;
			bodyText.scrollY = 0;
			addGraphic( bodyText );
			
			ShowPage();
		}
		
		override public function update():void 
		{
			if ( Input.mousePressed )
			{
				if( Input.mouseX >= closeButton.x && Input.mouseX <= closeButton.x + closeButton.width &&
					Input.mouseY >= closeButton.y && Input.mouseY <= closeButton.y + closeButton.height )
				{
					callback( this );
				}
				if( Input.mouseX >= prevButton.x && Input.mouseX <= prevButton.x + prevButton.width &&
					Input.mouseY >= prevButton.y && Input.mouseY <= prevButton.y + prevButton.height )
				{
					page--;
					if ( page < 1 )
						page = 1;
					ShowPage();
				}
				if( Input.mouseX >= nextButton.x && Input.mouseX <= nextButton.x + nextButton.width &&
					Input.mouseY >= nextButton.y && Input.mouseY <= nextButton.y + nextButton.height )
				{
					page++;
					if ( page > 3 )
						page = 3;
					ShowPage();
				}
			}
			
			super.update();
		}
		
		private function ShowPage():void
		{
			switch( page )
			{
				case 1:
					titleText.text = "Goal";
					bodyText.text = "You are the Sun God.\n\nYour goal is to bring life to your mostly barren solar system. You must send out your asteroids to harvest life from the worlds that do have it, and rain bacteria down onto other planets to seed them.\n\nThe game is over when all planets have 100% life.";
					break;
				case 2:
					titleText.text = "Controls";
					bodyText.text = "You can zoom in or out with the scroll wheel or plus/minus keys.\n\nTo send an asteroid out into the solar system, click on it then pull back and release.\n\nYou can control your asteroid mid-flight by holding the mouse button down and moving the mouse to aim its thruster.\n\nCrashing into worlds with life on them raises the asteroid's bacteria bar.\n\nIf you have bacteria, rain them down on a world by flying close to it without hitting it - getting into a stable orbit is best.";
					break;
				case 3:
					titleText.text = "Mechanics";
					bodyText.text = "Planets have Health and Life, shown as a red and green bar around them. Crashing into a planet lowers both Health and Life.\n\nHealth will recharge on its own. If there is some Life on a planet, it will multiply. The more life there is, the faster it will fill the bar itself.\n\nPlanets must be at full health in order to be seeded with life.\n\nRaining life down on planets increases your score and your multiplier. Running into a planet resets your multiplier to 1.";
					break;
			}
		}
		
	}

}