package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.tweens.motion.LinearMotion;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author Switchbreak
	 */
	public class UFO extends Entity 
	{
		
		public var xPosition:Number;
		public var yPosition:Number;
		
		private var UFOSprite:Image;
		private var indicator:Indicator;
		private var motionTween:LinearMotion;
		private var targetPlanet:Planet;
		
		public function UFO( setX:Number, setY:Number ) 
		{
			xPosition = setX;
			yPosition = setY;
			
			UFOSprite = Image.createRect( 100, 40, 0xFF0000 );
			UFOSprite.centerOrigin();
			
			super( setX * GameWorld.zoom, setY * GameWorld.zoom, UFOSprite );
			UFOSprite.scale = GameWorld.zoom;
			setHitboxTo( UFOSprite );
			
			// Create indicator object
			indicator = new Indicator( 0xFF0000 );
			indicator.visible = false;
			addGraphic( indicator );
			
			motionTween = new LinearMotion( null, LOOPING );
			addTween( motionTween );
		}
		
		override public function added():void 
		{
			super.added();
			
			PickPlanet();
		}
		
		override public function update():void 
		{
			if ( motionTween.active )
			{
				xPosition = motionTween.x;
				yPosition = motionTween.y;
				motionTween.setMotionSpeed( xPosition, yPosition, targetPlanet.xPosition, targetPlanet.yPosition - targetPlanet.radius - 200, 200 );
			}
			
			x = xPosition * GameWorld.zoom;
			y = yPosition * GameWorld.zoom;
			UFOSprite.scale = GameWorld.zoom;
			
			// Check if the planet is off the current screen
			if ( !onCamera )
			{
				indicator.PointAt( x, y );
				indicator.visible = true;
			}
			else
			{
				indicator.visible = false;
			}
			
			super.update();
		}
		
		public function Explode():void
		{
			world.remove( this );
		}
		
		private function PickPlanet():void
		{
			var planets:Vector.<Planet> = new Vector.<Planet>();
			world.getClass( Planet, planets );
			
			targetPlanet = planets[FP.rand( planets.length )];
			motionTween.setMotionSpeed( xPosition, yPosition, targetPlanet.xPosition, targetPlanet.yPosition - targetPlanet.radius - 200, 200 );
			motionTween.start();
		}
	}

}